PrefabFiles = {
	"lulu",
	"lulu_none",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/lulu.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/lulu.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/lulu.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/lulu.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/lulu_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/lulu_silho.xml" ),

    Asset( "IMAGE", "bigportraits/lulu.tex" ),
    Asset( "ATLAS", "bigportraits/lulu.xml" ),
	
	Asset( "IMAGE", "images/map_icons/lulu.tex" ),
	Asset( "ATLAS", "images/map_icons/lulu.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_lulu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_lulu.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_lulu.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_lulu.xml" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_lulu.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_lulu.xml" ),
	
	Asset( "IMAGE", "images/names_lulu.tex" ),
    Asset( "ATLAS", "images/names_lulu.xml" ),
	
    Asset( "IMAGE", "bigportraits/lulu_none.tex" ),
    Asset( "ATLAS", "bigportraits/lulu_none.xml" ),

}

TUNING.LULU_HP = GetModConfigData("lulu_hp") --180
TUNING.LULU_HUN = GetModConfigData("lulu_hunger")-- 120
TUNING.LULU_SANITY = GetModConfigData("lulu_sanity") --110
TUNING.LULU_PLANTLEVEL = GetModConfigData("get_fru") -- Every X Day
TUNING.LULU_DIET = GetModConfigData("lulu_diet") -- Lulu Eat Meat?
TUNING.LULU_MUSH = GetModConfigData("mash_open") -- Can any time collect mushrums
TUNING.LULU_EYE = GetModConfigData("eye_lulu") -- Eyeplant Attack Lulu?
TUNING.LULU_FLOWER_DEAD = GetModConfigData("lulu_flower_dead") -- Leave flower on dead
TUNING.LULU_CRAFT = GetModConfigData("lulu_craft") -- Can craft "lureplantbulb"

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

STRINGS.CHARACTER_TITLES.lulu = "The plantress"
STRINGS.CHARACTER_NAMES.lulu = "Lulu"
STRINGS.CHARACTER_DESCRIPTIONS.lulu = "*Starts the game with a fleshy bulb.\n*Get two random fruit per day.\n*Don`t eat meat."
STRINGS.CHARACTER_QUOTES.lulu = "\"My power in plants!\""

STRINGS.CHARACTERS.lulu = require "speech_lulu"

STRINGS.NAMES.lulu = "Lulu"

AddMinimapAtlas("images/map_icons/lulu.xml")


AddModCharacter("lulu", "FEMALE")

--Unuse OnActivate drop all collectet items
--[[
local function OnActivate(inst, doer)
    if not inst.activatedonce and doer:HasTag("Lulu") then
        inst.activatedonce = false
        inst.components.lootdropper:DropLoot(inst:GetPosition())
	    inst.components.activatable.inactive = true
    end
end

AddPrefabPostInit("lureplant", function(inst)
	inst:AddComponent("activatable")    
    inst.components.activatable.OnActivate = OnActivate
    inst.components.activatable.inactive = true
    inst.components.activatable.quickaction = true
end)
--]]

local _G = GLOBAL
local RECIPETABS = _G.RECIPETABS
local TECH = _G.TECH
local Ingredient = _G.Ingredient

--Craft
if TUNING.LULU_CRAFT == 1 then
local lulu_recipe = AddRecipe( "lureplantbulb",
{Ingredient("dug_berrybush", 1),
Ingredient("nightmarefuel", 5)} ,
RECIPETABS.TOWN, 
TECH.NONE,
nil,
nil,
nil,
nil,
"Lulu"
)

lulu_recipe.sortkey = 1
end
--Mushrum open on Lulu near
local function open_any(inst, player)
    if player:HasTag("Lulu") and not inst.AnimState:IsCurrentAnimation("picked") and TUNING.LULU_MUSH == 1 then
        if inst.components.pickable ~= nil and inst.components.pickable:CanBePicked() then
            inst.components.pickable.caninteractwith = true
        end
	    if inst.prefab == "green_mushroom" then
 	        inst.AnimState:PlayAnimation("green")
	    end
	    if inst.prefab == "red_mushroom" then
 	        inst.AnimState:PlayAnimation("red")
	    end
	    if inst.prefab == "blue_mushroom" then
 	        inst.AnimState:PlayAnimation("blue")
	    end
	end
end
--Cheack cycle and closet mushrum if need.
local function lulu_far(inst)
	if inst.prefab == "green_mushroom" and inst.components.pickable ~= nil and inst.mashphase ~= "dusk" and not inst.AnimState:IsCurrentAnimation("picked") then
        if inst.components.pickable:CanBePicked() then
			inst.components.pickable.caninteractwith = false
		    inst.growtask = nil
		    inst.AnimState:PlayAnimation("inground")
        end
    end
	if inst.prefab == "red_mushroom" and inst.components.pickable ~= nil and inst.mashphase ~= "day" and not inst.AnimState:IsCurrentAnimation("picked") then
        if inst.components.pickable:CanBePicked() then
			inst.components.pickable.caninteractwith = false
		    inst.growtask = nil
		    inst.AnimState:PlayAnimation("inground")
        end
    end
	if inst.prefab == "blue_mushroom" and inst.components.pickable ~= nil and inst.mashphase ~= "night" and not inst.AnimState:IsCurrentAnimation("picked") then
        if inst.components.pickable:CanBePicked() then
			inst.components.pickable.caninteractwith = false
		    inst.growtask = nil
		    inst.AnimState:PlayAnimation("inground")
        end
    end
end
-- Cheach World phase
local function check_phase(inst, phase)
    inst.mashphase = phase
end
--Add new cycle system to mushrums.
AddPrefabPostInit("red_mushroom", function(inst)
	inst:AddComponent("playerprox") -- Near Player checaer
    inst.components.playerprox:SetDist(4, 5) -- Check dist
    inst.components.playerprox:SetOnPlayerNear(open_any) -- On player(Lulu) near
    inst.components.playerprox:SetOnPlayerFar(lulu_far) -- On player(Lulu) far
	inst:WatchWorldState("phase", check_phase)
    check_phase(inst, GLOBAL.TheWorld.state.phase)
end)

AddPrefabPostInit("green_mushroom", function(inst)
	inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(4, 5)
    inst.components.playerprox:SetOnPlayerNear(open_any)
	inst.components.playerprox:SetOnPlayerFar(lulu_far)
	inst:WatchWorldState("phase", check_phase)
    check_phase(inst, GLOBAL.TheWorld.state.phase)
end)

AddPrefabPostInit("blue_mushroom", function(inst)
	inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(4, 5)
    inst.components.playerprox:SetOnPlayerNear(open_any)
	inst.components.playerprox:SetOnPlayerFar(lulu_far)
	inst:WatchWorldState("phase", check_phase)
    check_phase(inst, GLOBAL.TheWorld.state.phase)
end)

AddPrefabPostInit("plantmeat", function(inst)
    inst.components.edible.foodtype = "VEGGIE"
end)

AddPrefabPostInit("plantmeat_cooked", function(inst)
    inst.components.edible.foodtype = "VEGGIE"
end)


