
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {
    Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
}
local prefabs = {}

-- Custom starting items
local start_inv = {
    "lureplantbulb",
}

local common_postinit = function(inst) 
	inst.MiniMapEntity:SetIcon( "lulu.tex" )
	inst:AddTag("Lulu")
	inst:AddTag("Lulu_eye")
end

local fruit_list =
{
    "pomegranate",
    "dragonfruit",
    "durian",
    "watermelon",
    "cave_banana",
    "carrot",
	"pumpkin",
	"corn",
	"eggplant",
	--"mandrake",
	"berries",
	"red_cap",
	"green_cap",
	"blue_cap",
	"wormlight",
	"cactus_meat",
}

local function OnDeath(inst)
    if TUNING.LULU_FLOWER_DEAD == 1 then
	inst.components.inventory:GiveItem(SpawnPrefab("petals"))
	inst.components.inventory:DropEverything()
	inst.components.inventory:GiveItem(SpawnPrefab("petals"))
	inst.components.inventory:DropEverything()
	inst.components.inventory:GiveItem(SpawnPrefab("petals"))
	inst.components.inventory:DropEverything()
	inst.components.inventory:GiveItem(SpawnPrefab("petals"))
	inst.components.inventory:DropEverything()
	inst.components.inventory:GiveItem(SpawnPrefab("petals"))
	inst.components.inventory:DropEverything()
	end
end

local function GetFruit(inst)
	inst.components.inventory:GiveItem(SpawnPrefab(fruit_list[math.random(#fruit_list)]))
	inst.components.inventory:GiveItem(SpawnPrefab(fruit_list[math.random(#fruit_list)]))
	inst.components.talker:Say("New crop of vegetables!")
end

local function New_Spawn(inst)
	inst.components.inventory:GiveItem(SpawnPrefab(fruit_list[math.random(#fruit_list)]))
	inst.components.inventory:GiveItem(SpawnPrefab(fruit_list[math.random(#fruit_list)]))
end

local function OnDayComplete(inst)
    if TUNING.LULU_PLANTLEVEL ~= 0 then
        if inst.plant_level <TUNING.LULU_PLANTLEVEL then
            inst.plant_level=inst.plant_level+1
	    end
	    if inst.plant_level == TUNING.LULU_PLANTLEVEL then
            inst.plant_level = 0
		    GetFruit(inst)
	    end
	end
end

local master_postinit = function(inst)

	inst.soundsname = "wendy"
	
	inst.plant_level = 0
	
	inst.components.health:SetMaxHealth(TUNING.LULU_HP)
	inst.components.hunger:SetMax(TUNING.LULU_HUN)
	inst.components.sanity:SetMax(TUNING.LULU_SANITY)
	
    if TUNING.LULU_DIET == 0 then
	    inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODTYPE.VEGGIE, FOODTYPE.GOODIES, FOODTYPE.INSECT, FOODTYPE.SEEDS, FOODTYPE.GENERIC })
	end

    inst.components.combat.damagemultiplier = 1.25
	
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE
	
	inst.components.sanity.night_drain_mult = TUNING.WENDY_SANITY_MULT

    inst.OnNewSpawn = New_Spawn
	
	inst:WatchWorldState("cycles", OnDayComplete)
	inst:ListenForEvent("death", OnDeath)
	
	if TUNING.LULU_EYE == 1 then
	    inst:RemoveTag("Lulu_eye")
	end
	
end

return MakePlayerCharacter("lulu", prefabs, assets, common_postinit, master_postinit, start_inv)
